package org.bdware.sc;

import org.bdware.sc.bean.ProjectConfig;
import org.bdware.sc.db.CMTables;
import org.bdware.sc.db.StatusRecorder;

public class ProjectRecorder extends StatusRecorder<ProjectConfig> {
    static final String dbName = CMTables.ProjectConfig.toString();
    static final String prefix = "Project_Config_";
//    private static final Logger LOGGER = LogManager.getLogger(ProjectRecorder.class);

    public ProjectRecorder(String dir) {
        super(dir, dbName, prefix);
    }

    public ProjectConfig getProjectConfig(String idOrNameOrDOI) {
        if (null == idOrNameOrDOI) {
            return null;
        }
        ContractMeta meta = ContractManager.instance.statusRecorder.getContractMeta(idOrNameOrDOI);
        if (meta == null) {
            return null;
        }
        if (null == meta.contract.sourcePath) {
            if (meta.contract.getScriptStr().contains("public")) {
                meta.contract.sourcePath = "public/" + meta.name;
            } else {
                meta.contract.sourcePath = meta.contract.getPublicKey() + "/" + meta.name;
            }
        }
        ProjectConfig config = getStatus().get(meta.contract.sourcePath);
        if (config == null) {
            return createDefaultConfig(meta.contract.sourcePath);
        } else {
            return config;
        }
    }

    public ProjectConfig createDefaultConfig(String sourcePath) {
        ProjectConfig config = new ProjectConfig(sourcePath);

        updateValue(config);
        return config;
    }

}
