package org.bdware.sc.units;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.bouncycastle.crypto.params.ECPublicKeyParameters;
import org.zz.gmhelper.BCECUtil;
import org.zz.gmhelper.SM2Util;

public class ContractUnitMessage implements Serializable {

	private static final long serialVersionUID = 584934384202845750L;
	ContractUnitType type;
	private String contractID;
	String requestID;
	String signature;
	byte[] content;

	public ContractUnitMessage(String requestID, String contractID, byte[] sender) {
		this.requestID = requestID;
		this.setContractID(contractID);
	}

	public ContractUnitMessage() {
		// TODO Auto-generated constructor stub
	}

	public static ContractUnitMessage parse(byte[] b) {
		try {
			ByteArrayInputStream bi = new ByteArrayInputStream(b);
			ObjectInputStream input = new ObjectInputStream(bi);
			ContractUnitMessage ret = (ContractUnitMessage) input.readObject();
			return ret;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public byte[] toByteArray() {
		try {
			ByteArrayOutputStream bo = new ByteArrayOutputStream();
			ObjectOutputStream output = new ObjectOutputStream(bo);
			output.writeObject(this);
			return bo.toByteArray();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}


	private static String IDA = "PBFTMsg";

//	public void sign(NodeInfo info) {
//		sender = info.getNodeID();
//		signature = sm02.sign(content, IDA, info.privKey).toString();
//	}

	public boolean verify(ContractUnitMember member) {
		ECPublicKeyParameters param = BCECUtil.createECPublicKeyFromStrParameters(member.pubKey,SM2Util.CURVE,SM2Util.DOMAIN_PARAMS);

		return SM2Util.verify(param,content, signature.getBytes());
	}

	public void setType(ContractUnitType type) {
		this.type = type;
	}

	public ContractUnitType getType() {
		return type;
	}

	public byte[] getContent() {
		return content;
	}

	public void setContent(byte[] content) {
		this.content = content;
	}

	public String getContractID() {
		return contractID;
	}

	public String getRequestID() {
		return requestID;
	}

	public String getDisplayStr() {
		StringBuilder sb = new StringBuilder();
		sb.append(requestID);
		sb.append("_TYPE_").append(type);
		sb.append("_");
		sb.append(getContractID());
		sb.append("_");
		sb.append(" content:");
		sb.append(new String(content));
		return sb.toString();
	}

	public void setContractID(String contractID) {
		this.contractID = contractID;
	}

}
