package org.bdware.sc.units;

import org.junit.Test;

public class RespCacheTest {
    @Test
    public void timeOutAllFalse() throws InterruptedException {
        RespCache cache = new RespCache();
        cache.count = 7;
        for (int i = 0; i < 7; i++) {
            final int j = i;
            new Thread(() -> {
                try {
                    Thread.sleep(j * 1000);
                    if (j > 2) Thread.sleep(6 * 1000);

                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                boolean waitResult = cache.waitForHalf();
                System.out.println(
                        "tid:"
                                + Thread.currentThread().getId()
                                + " reach target, waitResult:"
                                + waitResult);
            }).start();
        }
        Thread.sleep(20000);
    }

    @Test
    public void inTimeAllTrue() throws InterruptedException {
        RespCache cache = new RespCache();
        cache.count = 7;
        for (int i = 0; i < 7; i++) {
            final int j = i;
            new Thread(() -> {
                try {
                    Thread.sleep(j * 1000);
                    if (j > 2) Thread.sleep(1900);

                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                boolean waitResult = cache.waitForHalf();
                System.out.println(
                        "tid:"
                                + Thread.currentThread().getId()
                                + " reach target, waitResult:"
                                + waitResult);
            }).start();
        }
        Thread.sleep(20000);
    }

    @Test
    public void fastAllTrue() throws InterruptedException {
        RespCache cache = new RespCache();
        cache.count = 7;
        for (int i = 0; i < 7; i++) {
            new Thread(() -> {
                try {
                    Thread.sleep(1000);

                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                boolean waitResult = cache.waitForHalf();
                System.out.println(
                        "tid:"
                                + Thread.currentThread().getId()
                                + " reach target, waitResult:"
                                + waitResult);
            }).start();
        }
        Thread.sleep(10000);
    }
}
